sub run {
	my ( $type, $cwd ) = @_ ;
	
	
	my $actual_cwd = $fckperl_config{ 'UserFilesPath' } . "/" . $type . $cwd ;
	
	my @folders ;
	
	if ( opendir( DIR, path( $actual_cwd ) ) ) {
		while ( defined( my $filename = readdir( DIR ) ) ) {
			next if ( $filename eq "." ) ;
			next if ( $filename eq ".." ) ;
			
			Jcode::convert( \$filename, 'utf8', $fckperl_config{ 'FileEncoding' } );
			
			next unless ( -d path( $actual_cwd . $filename ) ) ;
			
			# check if$fckphp_configured not to show this folder
			
			my $hide = 0;
			
			for( my $i = 0; $i < @{ $fckperl_config{ 'ResourceAreas' }{ $type }{ 'HideFolders' } }; $i++ ) {
				my $pattern = $fckperl_config{ 'ResourceAreas' }{ $type }{ 'HideFolders' }[ $i ] ;
				
				if ( $filename =~ /$pattern/ ) {
					$hide = 1 ;
					last ;
				}
			}
			
			next if ( $hide ) ;
			
			push( @folders, $filename ) ;
		}
		
		closedir( DIR ); 
	}
	
	@folders = sort( @folders ) ;
	
	print 'Content-Type: application/xml; charset=utf-8' . "\n" ;
	print "\n" ;
	print '<?xml version="1.0" encoding="utf-8" ?>' . "\n" ;
	print '<Connector command="GetFolders" resourceType="' . XMLEncode( $type ) . '">' . "\n" ;
	print '    <CurrentFolder path="' . XMLEncode( $cwd ) . '" url="' . XMLEncode( url( $actual_cwd ) ) . '" />' . "\n" ;
	
	print "    <Folders>\n" ;
	for ( my $i = 0; $i < @folders; $i++ ) {
		print '        ' ;
		print '<Folder' ;
		print ' name="' . XMLEncode( $folders[ $i ] ) . '"' ;
		print ' url="' . XMLEncode( url( $folders[ $i ] ) ) . '"' ;
		print ' />' ;
		print "\n" ;
	}
	print "    </Folders>\n" ;
	
	print "</Connector>\n" ;
}


1;
