use Image::Magick ;

sub run {
	my ( $type, $cwd ) = @_ ;
	
	
	my $filename = $_GET{ 'FileName' } ;
	
	my $actual_cwd = $fckperl_config{ 'UserFilesPath' } . "/" . $type . $cwd ;
	my $fullfile = $actual_cwd . $filename ;
	
	my $imagetype = getType( path( $fullfile ) ) ;
	
	if ( $imagetype ne '' ) {
		if ( $pckperl_config{ 'UseCache' } == 1 ) {
			my $thumb = $actual_cwd . '.thumb_' . $filename ;
			
			if ( ! -f path( $thumb ) ) {
				$image = createThumb( $fullfile ) ;
				$image->Write( path( $thumb ) ) ;
				undef $image ;
			}
			
			printImage( $filetype, $thumb ) ;
		} else {
			$image = createThumb( $fullfile ) ;
			print "Content-type: image/${ imagetype }\n" ;
			print "\n" ;
			
			binmode STDOUT ;
			$image->Write( "${ imagetype }:-" ) ;
			undef $image ;
		}
		
		return ;
	}
	
	printImage( 'jpeg', iconLookup( getExtension( $filename ) ) ) ;
}


sub printImage {
	my ( $imagetype, $file ) = @_ ;
	
	print "Content-type: image/${ imagetype }\n" ;
	print "\n" ;
	
	open( my $img, path( $file ) ) ;
	binmode $img ;
	binmode STDOUT ;
	print while ( <$img> ) ;
	close $img ;
}


sub getExtension {
	my ( $filename ) = @_ ;
	
	$filename =~ /^.*\.([^\.]*)$/ ;
	return $1 ;
}


sub getType {
	my ( $file ) = @_ ;
	
	
	open( my $fh, "<" . $file );
	
	read( $fh, my $start4, 4 ) ;
	my $start3 = substr( $start4, 0, 3 ) ;
	
	close( $fh ) ;
	
	return "png"	if ( $start4 eq "\x89PNG" ) ;
	return "gif"	if ( $start3 eq "GIF" ) ;
	return "jpeg"	if ( $start3 eq "\xFF\xD8\xFF" ) ;
	return "jpeg"	if ( $start4 eq "hsi1" ) ;
	
	my $ext = getExtension( $file ) ;
	
	return "gif"	if ( $ext eq "gif" ) ;
	return "jpeg"	if ( $ext eq "jpg" ) ;
	return "jpeg"	if ( $ext eq "jpeg" ) ;
	return "png"	if ( $ext eq "png" ) ;
	
	return '' ;
}


sub iconLookup {
	my ( $ext ) = @_ ;
	
	
	my $icon = $fckperl_config{ 'iconLookupDir' } ;
	
	my @extensions = keys( %{ $fckperl_config{ 'extIcons'} } ) ;
	
	$icon .= ( in_array( $ext, \@extensions ) ) ? $fckperl_config{ 'extIcons' }{ $ext } : "/empty.jpg" ;
	
	return $icon;
}


sub createThumb {
	my ( $fullfile ) = @_ ;
	
	
	my $size = 96 ;
	
	my $img = new Image::Magick ;
	
	$img->Read( path( $fullfile ) ) ;
	$img = $img->Transform( geometry => "${ size }x${ size }" ) ;
	
	my $back = new Image::Magick ;
	
	$back->Set( size => "${ size }x${ size }" ) ;
	$back->Read() ;
	$back->Colorize( fill => "#ffffff" ) ;
	
	$back->Composite( image => $img, compose => 'over', gravity => 'center' ) ;
	
	undef $img ;
	
	return $back ;
}


1;
