=comment
Perl Connector for the FCKEditor v2 File Manager
Written By Akira Taniguchi, JP, Dec 2006
http://akira.matrix.jp/

FCKEditor - By Frederico Caldeira Knabben
http://www.fckeditor.net/

File Description:
Configuration file
=cut

use strict ;
use vars qw(%fckperl_config $DIRECTORY_SEPARATOR) ;

#/*------------------------------------------------------------------------------*/
#/* Encoding of file system					*/
#/*------------------------------------------------------------------------------*/
$fckperl_config{'FileEncoding'} = 'utf8' ;
#/*==============================================================================*/


#/*------------------------------------------------------------------------------*/
#/* Path to user files relative to the document root (no trailing slash)		*/
#/*------------------------------------------------------------------------------*/
$fckperl_config{'UserFilesPath'} = "/UserFiles" ;
#/*==============================================================================*/


#/*------------------------------------------------------------------------------*/
#/* Use Cache																		*/
#/*------------------------------------------------------------------------------*/
$fckperl_config{'UseCache'} = 0 ;	# 0/1 = Unuse/Use
#/*==============================================================================*/


#/*------------------------------------------------------------------------------*/
#/* Global Disk Quota - Max size of all resource areas				*/
#/*------------------------------------------------------------------------------*/
$fckperl_config{'DiskQuota'}{'Global'} = 40 ;	# In MBytes (default: 50mb)
#/*==============================================================================*/


#/*------------------------------------------------------------------------------*/
#/* Per resource area settings:-							*/
#/* - AllowedExtensions	:: Array, allowed file extensions (in lowercase)	*/
#/* - AllowedMIME	:: Array, allowed mime types (in lowercase)		*/
#/* - MaxSize		:: Number, Maximum size of file uploads in KBytes	*/
#/* - DiskQuota		:: Number, Maximum size allowed for the resource area in MByte	*/
#/* - HideFolders	:: Array, RegExp, matching folder names will be hidden	*/
#/* - HideFiles		:: Array, RegExp, matching file names will be hidden	*/
#/*------------------------------------------------------------------------------*/

#//File Area
%{ $fckperl_config{'ResourceAreas'}{'File'} }	= () ;
@{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }	= () ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "zip" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "doc" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "xls" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "pdf" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "rtf" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "csv" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "jpg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "gif" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "jpeg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "png" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "avi" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "mpg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "mpeg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "swf" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedExtensions'} }, "fla" ) ;
@{ $fckperl_config{'ResourceAreas'}{'File'}{'AllowedMIME'} }		= () ;
$fckperl_config{'ResourceAreas'}{'File'}{'MaxSize'}					= 1024 * 20 ;	# KBytes
$fckperl_config{'ResourceAreas'}{'File'}{'DiskQuota'}				= 10 ;			# MBytes
@{ $fckperl_config{'ResourceAreas'}{'File'}{'HideFolders'} }		= ( '^\.' ) ;
@{ $fckperl_config{'ResourceAreas'}{'File'}{'HideFiles'} }			= ( '^\.' ) ;

#//Image area
%{ $fckperl_config{'ResourceAreas'}{'Image'} }	= () ;
@{ $fckperl_config{'ResourceAreas'}{'Image'}{'AllowedExtensions'} }	= () ;
push( @{ $fckperl_config{'ResourceAreas'}{'Image'}{'AllowedExtensions'} }, "jpg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Image'}{'AllowedExtensions'} }, "gif" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Image'}{'AllowedExtensions'} }, "jpeg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Image'}{'AllowedExtensions'} }, "png" ) ;
@{ $fckperl_config{'ResourceAreas'}{'Image'}{'AllowedMIME'} }			= () ;
$fckperl_config{'ResourceAreas'}{'Image'}{'MaxSize'}				= 1024 * 20 ;	# KBytes
$fckperl_config{'ResourceAreas'}{'Image'}{'DiskQuota'}				= 10 ;			# MBytes
@{ $fckperl_config{'ResourceAreas'}{'Image'}{'HideFolders'} }		= ( '^\.' ) ;
@{ $fckperl_config{'ResourceAreas'}{'Image'}{'HideFiles'} }			= ( '^\.' ) ;

#//Flash area
%{ $fckperl_config{'ResourceAreas'}{'Flash'} }	= () ;
@{ $fckperl_config{'ResourceAreas'}{'Flash'}{'AllowedExtensions'} }	= () ;
push( @{ $fckperl_config{'ResourceAreas'}{'Flash'}{'AllowedExtensions'} }, "swf" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Flash'}{'AllowedExtensions'} }, "fla" ) ;
@{ $fckperl_config{'ResourceAreas'}{'Flash'}{'AllowedMIME'} }		= () ;
$fckperl_config{'ResourceAreas'}{'Flash'}{'MaxSize'}				= 1024 * 20 ;	# KBytes
$fckperl_config{'ResourceAreas'}{'Flash'}{'DiskQuota'}				= 10 ;			# MBytes
@{ $fckperl_config{'ResourceAreas'}{'Flash'}{'HideFolders'} }		= ( '^\.' ) ;
@{ $fckperl_config{'ResourceAreas'}{'Flash'}{'HideFiles'} }			= ( '^\.' ) ;

#//Media area
%{ $fckperl_config{'ResourceAreas'}{'Media'} }	= () ;
@{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }	= () ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "swf" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "fla" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "jpg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "gif" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "jpeg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "png" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "avi" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "mpg" ) ;
push( @{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedExtensions'} }, "mpeg" ) ;
@{ $fckperl_config{'ResourceAreas'}{'Media'}{'AllowedMIME'} }		= () ;
$fckperl_config{'ResourceAreas'}{'Media'}{'MaxSize'}				= 1024 * 20 ;	# KBytes
$fckperl_config{'ResourceAreas'}{'Media'}{'DiskQuota'}				= 10 ;			# MBytes
$fckperl_config{'ResourceAreas'}{'Media'}{'HideFolders'}			= ( '^\.' ) ;
$fckperl_config{'ResourceAreas'}{'Media'}{'HideFiles'}				= ( '^\.' ) ;

#/*==============================================================================*/		


#/*------------------------------------------------------------------------------*/
#/* Directory and File Naming :-							*/
#/*  -AvailableMax		:: Maximum number of available files				*/
#/*  -DisableName		:: Disable name	(regexp)			*/
#/*------------------------------------------------------------------------------*/
$fckperl_config{'AvailableMax'}	= 200;
$fckperl_config{'DisableName'}	= '(^\..*$|^.*\.$)';
$fckperl_config{'DisableChars'}	= '[\\/:"*?<>|]';	# .*, *., \/:,;"*?<>|
#/*==============================================================================*/


#/*------------------------------------------------------------------------------*/
#/* Internals :-									*/
#/*	ResourceTypes :: Array of valid resource areas				*/
#/*	Commands :: Array of valid commands accepted by the connector		*/
#/*------------------------------------------------------------------------------*/
@{ $fckperl_config{'ResourceTypes'} } = ();
push( @{ $fckperl_config{'ResourceTypes'} }, 'File' ) ;
push( @{ $fckperl_config{'ResourceTypes'} }, 'Image' ) ;
push( @{ $fckperl_config{'ResourceTypes'} }, 'Flash' ) ;
push( @{ $fckperl_config{'ResourceTypes'} }, 'Media' ) ;

@{ $fckperl_config{'Commands'} } = () ;
push( @{ $fckperl_config{'Commands'} }, "CreateFolder" ) ;
push( @{ $fckperl_config{'Commands'} }, "GetFolders" ) ;
push( @{ $fckperl_config{'Commands'} }, "GetFoldersAndFiles" ) ;
push( @{ $fckperl_config{'Commands'} }, "FileUpload" ) ;
push( @{ $fckperl_config{'Commands'} }, "Thumbnail" ) ;
push( @{ $fckperl_config{'Commands'} }, "DeleteFile" ) ;
push( @{ $fckperl_config{'Commands'} }, "DeleteFolder" ) ;
push( @{ $fckperl_config{'Commands'} }, "RenameFile" ) ;
push( @{ $fckperl_config{'Commands'} }, "RenameFolder" ) ;
#/*==============================================================================*/


#/*------------------------------------------------------------------------------*/
#/* Thumb command																*/
#/*------------------------------------------------------------------------------*/
%{ $fckperl_config{'extIcons'} }	= ();
$fckperl_config{'extIcons'}{"pdf"}	= "pdf.jpg";
$fckperl_config{'extIcons'}{"ps"}	= "postscript.jpg";
$fckperl_config{'extIcons'}{"eps"}	= "postscript.jpg";
$fckperl_config{'extIcons'}{"ai"}	= "postscript.jpg";
$fckperl_config{'extIcons'}{"ra"}	= "real_doc.jpg";
$fckperl_config{'extIcons'}{"rm"}	= "real_doc.jpg";
$fckperl_config{'extIcons'}{"ram"}	= "real_doc.jpg";
$fckperl_config{'extIcons'}{"wav"}	= "sound.jpg";
$fckperl_config{'extIcons'}{"mp3"}	= "sound.jpg";
$fckperl_config{'extIcons'}{"ogg"}	= "sound.jpg";
$fckperl_config{'extIcons'}{"eml"}	= "email.jpg";
$fckperl_config{'extIcons'}{"tar"}	= "tar.jpg";
$fckperl_config{'extIcons'}{"zip"}	= "tar.jpg";
$fckperl_config{'extIcons'}{"bz2"}	= "tar.jpg";
$fckperl_config{'extIcons'}{"tgz"}	= "tar.jpg";
$fckperl_config{'extIcons'}{"gz"}	= "tar.jpg";
$fckperl_config{'extIcons'}{"rar"}	= "tar.jpg";
$fckperl_config{'extIcons'}{"avi"}	= "video.jpg";
$fckperl_config{'extIcons'}{"mpg"}	= "video.jpg";
$fckperl_config{'extIcons'}{"mpeg"}	= "video.jpg";
$fckperl_config{'extIcons'}{"jpg"}	= "image.jpg";
$fckperl_config{'extIcons'}{"gif"}	= "image.jpg";
$fckperl_config{'extIcons'}{"png"}	= "image.jpg";
$fckperl_config{'extIcons'}{"jpeg"}	= "image.jpg";
$fckperl_config{'extIcons'}{"nfo"}	= "info.jpg";
$fckperl_config{'extIcons'}{"xls"}	= "spreadsheet.jpg";
$fckperl_config{'extIcons'}{"csv"}	= "spreadsheet.jpg";
$fckperl_config{'extIcons'}{"html"}	= "html.jpg";
$fckperl_config{'extIcons'}{"doc"}	= "document2.jpg";
$fckperl_config{'extIcons'}{"rtf"}	= "document2.jpg";
$fckperl_config{'extIcons'}{"txt"}	= "document2.jpg";
$fckperl_config{'extIcons'}{"xla"}	= "document2.jpg";
$fckperl_config{'extIcons'}{"xlc"}	= "document2.jpg";
$fckperl_config{'extIcons'}{"xlt"}	= "document2.jpg";
$fckperl_config{'extIcons'}{"xlw"}	= "document2.jpg";
$fckperl_config{'extIcons'}{"txt"}	= "document2.jpg";
#/*==============================================================================*/


1;
