<?php
// ################
// -- kijimenu_m
// ################
$sql = 'SELECT km_style1,km_style2,';
$sql .= 'p_code,p_seq,km_num,it_flg_day ,it_cond_st_day,it_cond_en_day,it_seq_day,it_asc_day';
for ($i = 1; $i <= 25; $i++) { $sql .= ',it_flg'.$i; }
for ($i = 1; $i <= 25; $i++) { $sql .= ',it_cond_st'.$i; }
for ($i = 1; $i <= 25; $i++) { $sql .= ',it_cond_en'.$i; }
for ($i = 1; $i <= 25; $i++) { $sql .= ',it_seq'.$i; }
for ($i = 1; $i <= 25; $i++) { $sql .= ',it_asc'.$i; }
$sql .= ' from kijimenu_m WHERE km_code = ?';
$stt=$db->prepare($sql);
$stt->bindParam(1, $km_code);
try {
	$stt->execute();
	if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) {
		$km_style1 = $cols['km_style1'];
		$km_style2 = $cols['km_style2'];
		$p_code = $cols['p_code'];
		$p_seq = $cols['p_seq'];
		$page_gyo = $cols['km_num'];
		// 入力日関連
		$it_flg_day = $cols['it_flg_day'];
		$it_cond_st_day = $cols['it_cond_st_day'];
		$it_cond_en_day = $cols['it_cond_en_day'];
		$it_seq_day = $cols['it_seq_day'];
		$it_asc_day = $cols['it_asc_day'];
		// 個別指定項目（MAX25項目）関連
		for ($i = 1; $i <= 25; $i++) {
			$it_flg[$i] = $cols['it_flg'.$i];
			$it_cond_st[$i] = $cols['it_cond_st'.$i];
			$it_cond_en[$i] = $cols['it_cond_en'.$i];
			$it_seq[$i] = $cols['it_seq'.$i];
			$it_asc[$i] = $cols['it_asc'.$i];
		}	
	}
} catch (PDOException $e) {
	echo $e->getMessage();
	exit();
}
// ###############
// ### parts_m ###
// ###############
$stt=$db->prepare('SELECT item, gyo FROM parts_m WHERE p_code = ?');
$stt->bindParam(1, $p_code);
try {
	$stt->execute();
	if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
		$item = $cols['item'];
		$gyo = $cols['gyo'];
	} 
} catch (PDOException $e) {
  echo $e->getMessage();
  exit();
}
// ######################################
// --  parts_item_c_m, parts_item_i_m
// ######################################
if ($gyo>0) {
	$item = mb_substr(($item.'nnnnnnnnnnnnnnnnnnnnnnnnn'),0,25); // 25byte未満を補う
	for ($i = 1; $i <= $gyo; $i++) {
		$it_kind[$i] = mb_substr($item,$i-1,1);				// 種別（c=文字.i=イメージ）
		if ($it_kind[$i]=='c') {
			$stt=$db->prepare('SELECT item_type, item_unit, item_unit_pre, item_inte, item_dec, item_link, item_clear FROM parts_item_c_m WHERE p_code = ? and p_seq = ?');
			$stt->bindParam(1, $p_code);
			$stt->bindParam(2, $i);
			try {
				$stt->execute();
				if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) {
					if ($i==$p_seq) {
						$item_link = $cols['item_link'];		// kijimenuに表示する項目
					}
					$it_type[$i] = $cols['item_type'];
					$it_inte[$i] = $cols['item_inte'];
					$it_dec[$i] = $cols['item_dec'];
				}
			} catch (PDOException $e) {
				echo $e->getMessage();
				exit();
			}
		}
	}
}
//########################
//--  抽出条件組み立て
//########################
$where = '';
// 入力日関連
if ($it_flg_day==1) {
	if ($where<>'') { $where .= ' AND '; }
	$where .= ' ent_date >="'.$it_cond_st_day.'" AND ent_date <="'.$it_cond_en_day.'" ';
}
// 一般項目
for ($i = 1; $i <= 25; $i++) {
	if ($it_flg[$i]==1) {
		$st = $it_cond_st[$i];
		$en = $it_cond_en[$i];
		if ($it_type[$i]=='nn' or $it_type[$i]=='nc') {	// 数値データの場合、整数桁、小数桁を0詰めして合わせる（大小比較の為）
			$st = str_pad(number_format($st,$it_dec[$i],'.',''), ($it_inte[$i]+($it_dec[$i]>0)*($it_dec[$i]+1)), "0", STR_PAD_LEFT);
			$en = str_pad(number_format($en,$it_dec[$i],'.',''), ($it_inte[$i]+($it_dec[$i]>0)*($it_dec[$i]+1)), "0", STR_PAD_LEFT);
		}
		if ($st>$en) {		// 大小逆の場合、差し替え
			list($st,$en) = array($en,$st);
		}
		if ($where<>'') { $where .= ' AND '; }
		$where .= 'k_data'.$i.' >= "'.$st.'" AND k_data'.$i.' <= "'.$en.'" ';
	}
}
if ($where<>'') { $where = ' AND '.$where; };
//########################
//--  表示順序組み立て
//########################
$order = '';
// 入力日関連
if ($it_seq_day>=1 and $it_seq_day<=($gyo+2)) {
	if ($by[$it_seq_day]<>'') { $by[$it_seq_day] .= ', '; }
	$by[$it_seq_day] .= 'ent_date ';
	if ($it_asc_day==1) { $by[$it_seq_day] .= 'desc '; }
}
// 一般項目
for ($i = 1; $i <= 25; $i++) {
	if ($it_seq[$i]>=1 and $it_seq[$i]<=($gyo+2)) {
		if ($by[$it_seq[$i]]<>'') { $by[$it_seq[$i]] .= ', '; }
		$by[$it_seq[$i]] .= 'k_data'.$i.' ';
		if ($it_asc[$i]==1) { $by[$it_seq[$i]] .= 'desc '; }
	}
}
// 組み立て
for ($i = 1; $i <= ($gyo+2); $i++) {
	if ($by[$i]<>'') {
		if ($order<>'') { $order .= ', '; }
		$order .= $by[$i];
	}
}
if ($order<>'') { $order = ' ORDER BY '.$order; }
//###################################
//-- 記事入力データ（リンク）セット
//###################################
$sql = 'SELECT k_code, k_data'.$p_seq.',kiji_http'.$p_seq.',kiji_url'.$p_seq.' FROM kiji_t WHERE p_code = ? '.$where.$order;
$stt=$db->prepare($sql);
$stt->bindParam(1, $p_code);
try {
	$dCnt = 0;
	$stt->execute();
	while ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
		++$dCnt;
		$k_code = $cols['k_code'];
		$k_data = $cols['k_data'.$p_seq];
		$kiji_http = $cols['kiji_http'.$p_seq];
		$kiji_url = $cols['kiji_url'.$p_seq];
		//##### 表示 #####
		$data[$dCnt] = '<li><a href="';
		if ($item_link=="2") {
			$data[$dCnt] .= $kiji_http.$kiji_url;
		} else {
			$data[$dCnt] .= $domain.$s_explanation.'?k_code='.$k_code;
		}
		$data[$dCnt] .= '">'.htmlspecialchars_decode($k_data).'</a></li>'."\n";
	}
} catch (PDOException $e) {
	echo $e->getMessage();
	exit();
}
//#################################
// -- ページインデックス組み立て
//#################################
$pager = '';
if (strpos(' '.$self2,'kijimenu_def2.php')>0 or strpos(' '.$self2,'site_def2.php')>0) {
	$tunagi = '&';	// パラメータが２個目以降
} else {
	$tunagi = '?';	// パラメータが１個目
}
if ($k_code2<>'') { $tunagi .= 'k_code='.$k_code2.'&'; }	// 記事明細頁の場合のパラメータを引き継ぐ
$self3 = $self2.$tunagi.'page_km'.$km_code.'_'.$Cnt.'=';
if ($dCnt>$page_gyo) {
	if ($page<1) { $page = 1; }
	if ($page_gyo<=0) { $page_gyo = 20; }	// 表示個数
	// 頁数
	$max_page = ceil($dCnt/$page_gyo);
	// 表示頁の開始と終了を割り出す
	if ($max_page<=5) {	// インデックスの幅=10 例：[3 4 5 6 7]
		$disp_min = 1;
		$disp_max = $max_page;
	} else {
		if ($page<3) {
			$disp_min = 1;
			$disp_max = 5;
		} else{
			if ($page>$max_page-3) {
				$disp_max = $max_page;
				$disp_min = $max_page - 4;
			} else{
				$disp_min = $page - 2;
				$disp_max = $page + 2;
			}
		}
	}
	// <前へ[
	if ($page>1) {
		$pager .= '<a href="'.$self3.($page-1).'">&lt;</a>';
	}
	$pager .= '[';
	// 数字部
	for ($i = $disp_min; $i <= $disp_max; $i++) {
		if ($i==$page) {
			$pager .= $i;
		} else {
			$pager .= '<a href="'.$self3.$i.'">'.$i.'</a>';
		}
		if ($i<$disp_max) { $pager .= ' '; }
	}
	// ]次へ>
	$pager .= ']';
	if ($page<$max_page) {
		$pager .= '<a href="'.$self3.($page+1).'">&gt;</a>';
	}
	$pager = '<div class="pager">'.$pager.'</div>'."\n";
}
//#########################
//--     表示
//#########################
//### 枠 ###
echo '<div class="kijimenu'.$km_code.'_'.$Cnt.'_1">'."\n";	// 外側のdiv（スタイル定義はcssにて）
echo '<div class="kijimenu'.$km_code.'_2">'."\n";			// 内側のdiv（〃）
echo '<ul>'."\n";
//### 中身 ###
if ($page<1) { $page = 1; }
if ($page_gyo<=0) { $page_gyo = 20; }	// 表示個数
for ($i = 1; $i <= $page_gyo; $i++) {
	if (($page_gyo*($page-1)+$i)<=$dCnt) {
		echo $data[$page_gyo*($page-1)+$i];
	}
}
//### 閉じる ###
echo '</ul>'."\n";
echo '</div>'."\n";
echo $pager;
echo '</div>'."\n";
?>