<?php
// ######################################################################
// --						記事クリエイター
$title=						   'ログイン';
// --		Copyright (C) 2009 Ompookan Inc. All rights reserved 
// ######################################################################
$self = 'login.php';				//<----------- このプログラム
$kanri = 'admin';					//管理用ユーザ名
$v_local_file = 'version.txt';						//バージョン管理ファイル（ローカル）
$v_server = 'http://ompookan.jp/yohen/support/';	//バージョン管理サーバ
$v_server_file = $v_server.'version_sv.txt';		//バージョン管理ファイル（サーバ）
$v_info_file   = $v_server.'version_info.txt';		//更新情報ファイル（サーバ）
$menu_num = 0;
include('kiji_common.php');
if ($link=='') { $link = 'parts_define.php'; }
// ######################################################################
// --   DBオープン
// ######################################################################
$dsn2  = 'sqlite:'.$db_path.'login.db';
try {
	$db2 = new PDO($dsn2);
} catch (PDOException $e) {
	echo 'PDO接続時<br />';
	echo $e->getMessage();
	exit();
}
$db2->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);
//-- レコード存在チェック
if ($btn<>'登録') {
	$stt=$db2->prepare('SELECT count(username) AS count_user FROM login_m WHERE username<>?');
	$stt->bindParam(1, $kanri);
	try {
		$stt->execute();
		if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
			$Cnt = $cols['count_user'];
			if ($Cnt==0) { $btn = 'new'; }
		} else {
			echo 'ログインマスタcount(username)読込時<br />';
			echo $e->getMessage();
			exit();
		}
	} catch (PDOException $e) {
		echo 'ログインマスタ読込時<br />';
		echo $e->getMessage();
		exit();
	}
}
// ##### 表示画面分岐指示 #####
$err = 0;
switch ($btn) {
	case 'ログイン':
	case 'ユーザ名・パスワード変更':
		$stt=$db2->prepare('SELECT password FROM login_m WHERE username=?');
		$stt->bindParam(1, $username);
		try {
			$stt->execute();
			if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
				$pass = $cols['password'];
				if (sha1($password)==$pass) {
					$invalid = 0;					// ログイン成功
				} else {
					$invalid = 2;					// 存在&&パスワード不一致
				}
			} else {
				$invalid = 1;						// ユーザ名なし
			}
		} catch (PDOException $e) {
			echo 'ログインマスタ読込時<br />';
			echo $e->getMessage();
			exit();
		}
		// ##### 画面遷移 or エラー表示 #####
		if ($invalid==0) {
			if ($btn=='ログイン') {
				session_set_cookie_params(0, $system_folder);
				session_start();
				$_SESSION['username'] = $username;
				$_SESSION['password'] = $pass;
				// -- バージョンチェック（Ompookan） --
				$fp = @fopen($v_server_file, 'r');
				if ($fp == true) {	// 該当ファイル
					if (! feof($fp)) {
						mb_language('Japanese');
					    $version_sv = mb_convert_encoding(fgets($fp), 'UTF-8', 'auto');
					}
					fclose($fp);
				}
				// -- バージョンチェック（自サーバ） --
				$version_lc = '';
				if (file_exists($v_local_file)) {
					$fp = fopen($v_local_file, 'r');
					if ($fp == true) {	// 該当ファイル
						if (! feof($fp)) {
							mb_language('Japanese');
							$version_lc = mb_convert_encoding(fgets($fp), 'UTF-8', 'auto');
						} else {
							$version_lc = 'V1.0';
						}
					} else {
						$version_lc = 'V1.0';
					}
					fclose($fp);
				} else {
					$version_lc = 'V1.0';
				}
				// -- 判断--
				if (mb_strpos('*'.$version_sv,'wait')==0 and $version_sv>$version_lc) {
					$goto = 'scr_vup1';
				} else {
					php_synchro();
					header('Location:'.$domain.ltrim($system_folder,'/').$link);
					exit();
				}
			} else {
				$stt=$db2->prepare('DELETE FROM login_m WHERE username=?');
				$stt->bindParam(1, $username);
				try {
					$stt->execute();
				} catch (PDOException $e) {
					echo 'ログインマスタ・レコード削除時<br />';
					echo $e->getMessage();
					exit();
				}
				$goto = 'scr_new';
			}
		} else {
			$goto = 'scr_login';
		}
		break;
	case '登録':
		$username = trim($username);
		$password = trim($password);
		$password2 = trim($password2);
		$err = 0;
		if ($username=='' or $password=='' or $password2=='') {
			$err = 1;
		} else {
			if (ereg('[^0-9a-zA-Z]',$username) or ereg('[^0-9a-zA-Z]',$password) or ereg('[^0-9a-zA-Z]',$password2)) {
				$err = 2;
			} else {
				if ($password<>$password2) {
					$err = 3;
				} else {
					if (strlen($username)<4 or strlen($password)<4 or strlen($password2)<4) {
						$err = 4;
					} else {
						if (strtoupper(trim($username))=='ADMIN') {
							$err = 5;
						}
					}
				}
			}
		}
		if ($err==0) {
			$stt=$db2->prepare('INSERT INTO login_m (username,password) VALUES (?,?)');
			$stt->bindParam(1, $username);
			$stt->bindParam(2, sha1($password));
			$db2->beginTransaction();
			try {
				$stt->execute();
				$db2->commit();
			} catch (PDOException $e) {
				echo '[ログインマスタ]登録時<br />';
				echo $e->getMessage();
				$db2->rollback();
				exit();
			}
			$invalid = 4;
			$goto = 'scr_login';
		} else {
			$goto = 'scr_new';
		}
		break;
	case 'new':
		$goto = 'scr_new';
		break;
	case 'logout':
		session_start();
		session_destroy();
		$invalid = 3;
		$goto = 'scr_login';
		break;
	case '保留':
		header('Location:'.$domain.ltrim($system_folder,'/').$link);
		exit();
		break;
	case '今すぐ実施する':
		$goto = 'scr_vup2';
		break;
	default:
		$goto = 'scr_login';
		break;
}
// ######################################################################
// --  バージョンアップ実施
// ######################################################################
if ($goto=='scr_vup2') {
$gamen = 4;
// ### DBオープン ###
try {
	$db = new PDO($dsn);
} catch (PDOException $e) {
	echo 'PDO接続時<br />';
	echo $e->getMessage();
	exit();
}
$db->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);
// ########## V3.7_002( 2011.1.23 17:00) ##########
if ($version_lc<'V3.7_002') {
	// --- 変更プログラム等ダウンロード --- 
	$fCnt = 0;
	++$fCnt; $local_file[$fCnt] = 'kiji_upload_dti.php';$server_file[$fCnt] = 'kiji_upload_dti.txt';
	++$fCnt; $local_file[$fCnt] = 'mini_01.php';		$server_file[$fCnt] = 'mini_01.txt';
	pg_get();	// ダウンロード実行
	//----- HDフラグが0でも1でもない場合0セット -----
	$sql="update kiji_t set k_data16='0' where p_code=1 and k_data16 is null";
	$stt=$db->prepare($sql);
	$stt->execute();
}
// ########## V3.7_003( 2011.2.2 20:00) ##########
if ($version_lc<'V3.7_003') {
	// --- 変更プログラム等ダウンロード --- 
	$fCnt = 0;
	++$fCnt; $local_file[$fCnt] = 'module_define.php';	$server_file[$fCnt] = 'module_define.txt';
	++$fCnt; $local_file[$fCnt] = 'module_disp.php';	$server_file[$fCnt] = 'module_disp.txt';
	++$fCnt; $local_file[$fCnt] = 'parts_design.php';	$server_file[$fCnt] = 'parts_design.txt';
	++$fCnt; $local_file[$fCnt] = 'parts_disp.php';		$server_file[$fCnt] = 'parts_disp.txt';
	++$fCnt; $local_file[$fCnt] = 'parts_disp_pre.php';	$server_file[$fCnt] = 'parts_disp_pre.txt';
	++$fCnt; $local_file[$fCnt] = 'parts_disp21.php';	$server_file[$fCnt] = 'parts_disp21.txt';
	++$fCnt; $local_file[$fCnt] = 'freeparts_define.php';$server_file[$fCnt] = 'freeparts_define.txt';
	++$fCnt; $local_file[$fCnt] = 'freeparts_disp.php';	$server_file[$fCnt] = 'freeparts_disp.txt';
	++$fCnt; $local_file[$fCnt] = 'sitemap.php';		$server_file[$fCnt] = 'sitemap.txt';
	++$fCnt; $local_file[$fCnt] = 'sitemap_disp.php';	$server_file[$fCnt] = 'sitemap_disp.txt';
	++$fCnt; $local_file[$fCnt] = 'kiji_common.php';	$server_file[$fCnt] = 'kiji_common.txt';
	++$fCnt; $local_file[$fCnt] = 'publish.php';		$server_file[$fCnt] = 'publish.txt';
	if (file_exists('../kijim/login.php')) {
		++$fCnt; $local_file[$fCnt] = '../kijim/module_define.php';	$server_file[$fCnt] = 'kijim/module_define.txt';
		++$fCnt; $local_file[$fCnt] = '../kijim/parts_design.php';	$server_file[$fCnt] = 'kijim/parts_design.txt';
		++$fCnt; $local_file[$fCnt] = '../kijim/freeparts_define.php';$server_file[$fCnt] = 'kijim/freeparts_define.txt';
		++$fCnt; $local_file[$fCnt] = '../kijim/kiji_common.php';	$server_file[$fCnt] = 'kijim/kiji_common.txt';
		++$fCnt; $local_file[$fCnt] = '../kijim/publish.php';		$server_file[$fCnt] = 'kijim/publish.txt';
	}
	pg_get();	// ダウンロード実行
}
//### バージョン（ローカル）更新 ###
$fp = fopen($v_local_file, 'w');
fwrite($fp,$version_sv."\r\n");
fclose($fp);
//### メニューへ移行 ###
header('Location:'.$domain.trim($system_folder,'/').'/'.$link);
}
//----------------------- Version up ここまで -----------------------
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Language" content="ja" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<meta name="author" content="Ompookan Inc." />
<title>ログイン</title>
<link rel="stylesheet" type="text/css" href="kiji.css" media="all" />
<link rel="stylesheet" href="js_color_picker_v2.css" media="screen" />
<script type="text/javascript" src="color_functions.js"></script>
<script type="text/javascript" src="js_color_picker_v2.js"></script>
<style type="text/css">
<!--
div.login_box {
	width: 460px;
	margin: 20px 150px;
	padding: 20px 20px 140px 20px;
<?php
if ($goto=='scr_vup1' or $goto=='scr_vup2') {
	echo 'background-image:none;'."\r\n";
	echo 'background-color:#FFFFCC;'."\r\n";
} else {
	echo 'background-image:url(images/login.gif);'."\r\n";
	echo 'background-repeat:no-repeat;'."\r\n";
}
?>
}
table.login {
	width: 460px;
	border-collapse: collapse;
}
table.login th {
	width: 170px;
	padding: 5px;
	text-align: right;
	color: #FFF;
/*	border:solid 1px #ddd; */
}
table.login td {
	padding: 5px;
	text-align: left;
	line-height: 2em;
/*	border:solid 1px #ddd; */
}
table.login td.text input {
	width: 120px;
	border: solid 2px #888888;
}
-->
</style>
<?php
// ### トップメニュー定義 ###
include('topmenu.txt');
?>
</head>
<body>
<?php
// ### 共通メニュー ###
include('head.txt');
//
?>
<div class="login_box">
<?php
switch ($goto) {
// ######################################################################
// --  ログイン
// ######################################################################
case 'scr_login':
$gamen = 1;
switch ($invalid) {
	case 1:
	case 2:
		$msg = '*** ユーザ名またはパスワードが違います ***';$cl = 'red';
		break;
	case 3:
		$msg = '*** ログアウトしました ***';$cl = 'green';
		break;
	case 4:
		$msg = '新規登録しました。ログインしてください。';$cl = 'green';
		break;
	default:
		$msg = "　";
		break;
}
?>
<form method="post" action="<?php echo $self?>">
<table class="login">
<tr>
	<td colspan="2" style="color:<?php echo @$cl?>">
	<?php echo @$msg?>
	</td>
</tr>
<tr>
	<th>ユーザ名 ：</th>
	<td class="text">
	<input id="username" name="username" size="20" value="<?php echo @$username?>" class="mode2" <?php echo @$kage?>/>
	</td>
</tr>
<tr>
	<th>パスワード ：</th>
	<td class="text">
	<input type="password" id="password" name="password" size="20" class="mode2" <?php echo @$kage?> />
	</td>
</tr>
<tr>
	<th></th>
	<td>
	<input type="submit" name="btn" value="ログイン" border="0" />
	<br /><br /><br /><br />
	<input type="submit" name="btn" value="ユーザ名・パスワード変更" border="0" />
	</td>
</tr>
</table>
<input type="hidden" name="link" value="<?php echo $link; ?>" />
</form>
<?php
break;
// ######################################################################
// --  新規登録
// ######################################################################
case 'scr_new':
$gamen = 2;
switch ($err) {
	case 1:
		$msg = '*** ユーザ名またはパスワードが未入力です ***';$cl = 'red';
		break;
	case 2:
		$msg = '*** 英数字のみです ***';$cl = 'red';
		break;
	case 3:
		$msg = '*** 二つのパスワードが一致しません ***';$cl = 'red';
		break;
	case 4:
		$msg = '*** それぞれ４文字以上お願いします ***';$cl = 'red';
		break;
	case 5:
		$msg = '*** admin は管理用ユーザ名です ***';$cl = 'red';
		break;
	default:
		$msg = "ユーザ名、パスワードを新規に登録してください。";$cl = 'green';
		break;
}
?>
<form method="post" action="<?php echo $self?>">
<table class="login">
<tr>
	<td colspan="2" style="color:<?php echo @$cl?>">
	<?php echo @$msg?>
	</td>
</tr>
<tr>
	<th>ユーザ名 ：</th>
	<td class="text">
	<input id="username" name="username" size="20" value="<?php echo @$username?>" class="mode2" <?php echo @$kage?>/>
	</td>
</tr>
<tr>
	<th>パスワード ：</th>
	<td class="text">
	<input type="password" id="password" name="password" size="20" class="mode2" <?php echo @$kage?> />
	</td>
</tr>
<tr>
	<th>パスワード（もう一度） ：</th>
	<td class="text">
	<input type="password" id="password2" name="password2" size="20" class="mode2" <?php echo @$kage?> />
	</td>
</tr>
<tr>
	<th></th>
	<td>
	<input type="submit" name="btn" value="登録" border="0" />
	</td>
</tr>
</table>
</form>
<?php
break;
// ######################################################################
// --  バージョンアップ確認
// ######################################################################
case 'scr_vup1':
$gamen = 3;
// #######################
// ### login.phpを取得 ###
// #######################
//
if ($fp = fopen($v_server.'login.txt', 'r')) {
	$fp2 = fopen('login.php','w');
	while (!feof($fp)) {
		$text = fgets ($fp, 4096);
		fwrite($fp2,$text);
	}
	fclose ($fp2);
	fclose ($fp);
    echo 'バージョンアップ情報を受信しました。<br />';
}
// ##################################
// ### バージョンアップ情報を取得 ###
// ##################################
$vCnt = 0;
$fp = fopen($v_info_file, 'r');
if ($fp == true) {	//該当ファイルがあった
	while (! feof($fp)) {
		mb_language('Japanese');
	    $src = mb_convert_encoding(fgets($fp), 'UTF-8', 'auto');
		$p01 = mb_strpos($src,'<version>');
		if ($p01>0) {
			$p02 = mb_strpos($src,'</version>');
			if ($p02>0) {
				++$vCnt;
				$version_name[$vCnt] = mb_substr($src,($p01+9),($p02-$p01-9));
			}
		} else {
			$version_info[$version_name[$vCnt]] .= nl2br($src);
		}
	}
}
?>
今すぐバージョンアップを実施しますか？<br /><br />
<div style="background-color:white;padding:5px;">
バージョンアップ内容<br />
<br />
<?php
for ($i = 1; $i <= $vCnt; $i++) {
	if ($version_name[$i]>$version_lc) {
		echo '【'.$version_name[$i].'】<br />';
		echo $version_info[$version_name[$i]].'<br /><br />';
	}
}
?>
</div>
<form method="post" action="<?php echo $self?>">
<div>
<br />
<span style="float:left;"><input type="submit" name="btn" value="今すぐ実施する" border="0" /></span>
<span style="float:right;"><input type="submit" name="btn" value="保留" border="0" /></span>
</div>
<input type="hidden" name="link" value="<?php echo $link; ?>" />
<input type="hidden" name="username" value="<?php echo $username; ?>" />
<input type="hidden" name="password" value="<?php echo $password; ?>" />
<input type="hidden" name="version_sv" value="<?php echo $version_sv; ?>" />
<input type="hidden" name="version_lc" value="<?php echo $version_lc; ?>" />
</form>
<?php
break;
}	//-- end of switch
?>
</div>
<?php
include('bottom.txt');
// ######################################################################
// --  プログラムファイル　ダウンロード実行
// ######################################################################
function pg_get(){
	global $v_server;
	global $fCnt;
	global $local_file;
	global $server_file;
	for ($i = 1; $i <= $fCnt; $i++) {
		if ($fp = fopen($v_server.$server_file[$i], 'r')) {
			$fp2 = fopen($local_file[$i],'w');
			while (!feof($fp)) {
				$text = fgets ($fp, 4096);
				fwrite($fp2,$text);
			}
			fclose ($fp2);
			fclose ($fp);
		}
	}
}
function pg_getb(){
	global $v_server;
	global $fCnt;
	global $local_file;
	global $server_file;
	for ($i = 1; $i <= $fCnt; $i++) {
		$fp = fopen($v_server.$server_file[$i], "rb" );
		$fp2 = fopen($local_file[$i],'wb');
		$imgdata = '';
		while (!feof($fp)) {
			$imgdata .= fread($fp, 8192);
		}
		fwrite($fp2,$imgdata);
		fclose($fp2);
		fclose($fp);
	}
}
// ######################################################################
// --  phpソースについてＤＢからテキストファイルを出力
// ######################################################################
function php_synchro(){
	global $dsn;
	//--- DBオープン ---
	try {
		$db = new PDO($dsn);
	} catch (PDOException $e) {
		echo 'PDO接続時<br />';
		echo $e->getMessage();
		exit();
	}
	$master_ok = 0;
	$db->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);
	$sql = "SELECT name FROM sqlite_master WHERE name='php_m'";
	$stt=$db->prepare($sql);
	$stt->execute();
	if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
		if ($cols['name']=='php_m') {
			$master_ok = 1;
		}
	}
	//--- DB→ファイル ---
	if ($master_ok==1) {
		$stt=$db->prepare('SELECT php_key,php_source FROM php_m');
		try {
			$stt->execute();
			while ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
				$php_key    = $cols['php_key'];
				$php_source = $cols['php_source'];
				if ($php_key<>'' and $php_source<>'') {
					$fp = fopen($php_key.'.txt', "w");
					fwrite($fp,$php_source);
					fclose($fp);
					$fp = fopen('../kijim/'.$php_key.'.txt', "w");
					fwrite($fp,$php_source);
					fclose($fp);
				}
			} 
		} catch (PDOException $e) {
			echo '[php_m]シンクロ時　';
			echo $e->getMessage();
			exit();
		}
	}
}
?>