<?php
// ###############
// ### parts_m ###
// ###############
$stt=$db->prepare('SELECT item, gyo FROM parts_m WHERE p_code = ?');
$stt->bindParam(1, $p_code);
try {
	$stt->execute();
	if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
		$item = $cols['item'];
		$gyo = $cols['gyo'];
	} 
} catch (PDOException $e) {
  echo $e->getMessage();
  exit();
}
// ######################
// ### parts_design_m ###
// ######################
$stt=$db->prepare('SELECT source FROM parts_design_m WHERE p_code = ? and d_seq = ?');
$stt->bindParam(1, $p_code);
$stt->bindParam(2, $d_seq);
try {
	$stt->execute();
	if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) {
		$source = $cols['source'];
	} 
} catch (PDOException $e) {
	echo $e->getMessage();
	exit();
}
// ##### <hr />がある場合、最初と最後の<hr />を切れ目に（最大）三つに分割 #####
if ($source<>'') {
	$source = ' '.htmlspecialchars_decode($source);	// サーチ真偽判断し易くする為に、冒頭にスペース挿入（サーチ位置=0の場合考慮）
	$p01 = 0; $suu = 0;
	while ($p01>=0) {
		$p02 = mb_strpos($source,'<hr',$p01,'utf-8');
		if ($p02>0) {
			$p03 = mb_strpos($source,'/>',$p02,'utf-8');
			if ($p03!==false) {
				++$suu;
				$hr_st[$suu] = $p02;
				$hr_en[$suu] = $p03+2;
				if (($p03+2)<mb_strlen($source,'utf-8')) {
					$p01 = $p03+2;
				} else {
					$p01 = -999;
				}
			}
		} else {
			$p01 = -999;
		}
	}
}
if ($suu>0) {
	$source1 = mb_substr($source,0,$hr_st[1],'utf-8');
	if ($suu>1) {
		$source2 = mb_substr($source,$hr_en[1],($hr_st[$suu]-$hr_en[1]),'utf-8');
		$source3 = mb_substr($source,$hr_en[$suu],(mb_strlen($source,'utf-8')-$hr_en[$suu]),'utf-8');
	} else {
		$source2 = mb_substr($source,$hr_en[$suu],(mb_strlen($source,'utf-8')-$hr_en[$suu]),'utf-8');
		$source3 = '';
	}
} else {
	$source1 = '';
	$source2 = $source;
	$source3 = '';
}
// ##### 一旦ひと固まりにする #####
$src  = '<div class="parts'.$p_code.'_'.$d_seq.'_'.$Cnt2.'_1">';// 一番外側のdiv
$src .= $source1;												// 最初の<hr />より上のコンテンツ（あれば）
$src .= '<div class="parts'.$p_code.'_'.$d_seq.'_'.$Cnt2.'_2">';// ２番目のdiv（margin以外有効）
$src .= $source2;												// メインコンテンツ
$src .= '</div>';
$src .= $source3;												// 最後の<hr />より下のコンテンツ（あれば）
$src .= '</div>';
// ######################################
// --  parts_item_c_m, parts_item_i_m
// ######################################
if ($gyo>0) {
	$item = mb_substr(($item.'nnnnnnnnnnnnnnnnnnnnnnnnn'),0,25); // 25byte未満を補う
	for ($i = 1; $i <= $gyo; $i++) {
		$it_kind[$i] = mb_substr($item,$i-1,1);				// 種別（c=文字.i=イメージ）
		if ($it_kind[$i]=='c') {
			$stt=$db->prepare('SELECT item_type, item_unit, item_unit_pre, item_inte, item_dec, item_link, item_clear FROM parts_item_c_m WHERE p_code = ? and p_seq = ?');
			$stt->bindParam(1, $p_code);
			$stt->bindParam(2, $i);
			try {
				$stt->execute();
				if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) {
					$it_type[$i] = $cols['item_type'];
					$it_unit[$i] = $cols['item_unit'];
					$it_unit_pre[$i] = $cols['item_unit_pre'];
					$it_inte[$i] = $cols['item_inte'];
					$it_dec[$i] = $cols['item_dec'];
					$it_link[$i] = $cols['item_link'];
				}
			} catch (PDOException $e) {
				echo $e->getMessage();
				exit();
			}
		} else {
			$stt=$db->prepare('SELECT item_line_w, item_line_c, item_box_w, item_len_unit, item_box_h, item_margin_top, item_margin_right, item_margin_bottom , item_margin_left, item_link, item_float FROM parts_item_i_m WHERE p_code = ? and p_seq = ?');
			$stt->bindParam(1, $p_code);
			$stt->bindParam(2, $i);
			try {
				$stt->execute();
				if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
					$it_line_w[$i] = $cols['item_line_w'];
					$it_line_c[$i] = $cols['item_line_c'];
					$it_box_w[$i] = $cols['item_box_w'];
					$it_len_unit[$i] = $cols['item_len_unit'];
					$it_box_h[$i] = $cols['item_box_h'];
					$it_margin_top[$i] = $cols['item_margin_top'];
					$it_margin_right[$i] = $cols['item_margin_right'];
					$it_margin_bottom[$i] = $cols['item_margin_bottom'];
					$it_margin_left[$i] = $cols['item_margin_left'];
					$it_link[$i] = $cols['item_link'];
					$it_float[$i] = $cols['item_float'];
				}
			} catch (PDOException $e) {
				echo $e->getMessage();
				exit();
			}
		}
	}
}
// ### $sourceのイメージアイテムのwidth="...",height="..."の各文字列を一旦別の文字に置換しておく                    ###
// ### イメージハメ込みの際に、width,heightどちらかをスペースに置換することにより、表示する画像の縦横比率を確保する ###
if ($src<>'' and strpos(' '.$item,'i')>0) {
	$src = ' '.$src;	// サーチ真偽判断し易くする為に、冒頭にスペース挿入（サーチ位置=0の場合考慮）
	$p01 = 0;
	while ($p01>=0) {
		$p02 = mb_strpos($src,'<img',$p01,'utf-8');
		if ($p02>0) {
			$p03 = mb_strpos($src,'/>',$p02,'utf-8');
			if ($p03!==false) {
				$p041 = mb_strpos($src,'[$$$',$p02,'utf-8');
				if ($p041!==false and $p041<$p03) {
					$p042 = mb_strpos($src,']',$p041,'utf-8');
					if ($p042!==false and $p042<$p03) {
						$num = mb_substr($src,($p041+4),($p042-$p041-4),'utf-8');
						if ($num>=1 and $num<=25) {
							$p05 = mb_strpos($src,('width'),$p02,'utf-8');
							if ($p05!==false) {
								$p06 = mb_strpos($src,('"'),$p05,'utf-8');
								if ($p06!==false) {
									$p07 = mb_strpos($src,('"'),($p06+1),'utf-8');
									if ($p07!==false) {
										$len = $p07 - $p05 + 1;
										$pre = mb_substr($src,0,$p05,'utf-8');
										$aft = mb_substr($src,($p07+1),mb_strlen($src,'utf-8')-($p07+1),'utf-8');
										$img_width_size[$num] = mb_substr($src,($p06+1),($p07-$p06-1),'utf-8');
										if ($num>=10) { $add = 1; } else { $add = 0; }
										// [###1w###]...[###25w##] 後ろの#の数は、文字列の長さにより調節
										$img_width[$num] = '[###'.$num.'w'.str_repeat('#',($len-7-$add)).']';
										$img_width_bk[$num] = mb_substr($src,$p05,$len,'utf-8');
										$src = $pre.$img_width[$num].$aft;
									}
								}
							}
							$p05 = mb_strpos($src,('height'),$p02,'utf-8');
							if ($p05!==false) {
								$p06 = mb_strpos($src,('"'),$p05,'utf-8');
								if ($p06!==false) {
									$p07 = mb_strpos($src,('"'),($p06+1),'utf-8');
									if ($p07!==false) {
										$len = $p07 - $p05 + 1;
										$pre = mb_substr($src,0,$p05,'utf-8');
										$aft = mb_substr($src,($p07+1),mb_strlen($src,'utf-8')-($p07+1),'utf-8');
										$img_height_size[$num] = mb_substr($src,($p06+1),($p07-$p06-1),'utf-8');
										if ($num>=10) { $add = 1; } else { $add = 0; }
										// [###1w###]...[###25w##] 後ろの#の数は、文字列の長さにより調節
										$img_height[$num] = '[###'.$num.'h'.str_repeat('#',($len-7-$add)).']';
										$img_height_bk[$num] = mb_substr($src,$p05,$len,'utf-8');
										$src = $pre.$img_height[$num].$aft;
									}
								}
							}
							$len = $p03 - $p02 + 2;								// imgタグの長さ<img～/>
							$pre = mb_substr($src,0,$p02,'utf-8');
							$aft = mb_substr($src,($p03+2),mb_strlen($src,'utf-8')-($p03+2),'utf-8');
							if ($num>=10) { $add = 1; } else { $add = 0; }
							// [###1###]...[###25##] 後ろの#の数は、文字列の長さにより調節
							$img_tag[$num] = '[###'.$num.str_repeat('#',($len-6-$add)).']';
							$img_tag_bk[$num] = mb_substr($src,$p02,$len,'utf-8');
							$src = $pre.$img_tag[$num].$aft;
						} else {
							if (($p03+2)<mb_strlen($src,'utf-8')) {
								$p01 = $p03 + 2;
							} else {
								$p01 = -999;
							}			
						}
					} else {
						if (($p03+2)<mb_strlen($src,'utf-8')) {
							$p01 = $p03 + 2;
						} else {
							$p01 = -999;
						}			
					}
				} else {
					if (($p03+2)<mb_strlen($src,'utf-8')) {
						$p01 = $p03 + 2;
					} else {
						$p01 = -999;
					}			
				}
			} else {
				$p01 = -999;
			}
		} else {
			$p01 = -999;
		}
	}
}
?>