sub run {
	my ( $type, $cwd ) = @_ ;
	
	
	my $actual_cwd = $fckperl_config{ 'UserFilesPath' } . "/" . $type . $cwd ;
	
	my $err_no = _run( $actual_cwd ) ;
	
	print 'Content-Type: application/xml; charset=utf-8' . "\n" ;
	print "\n" ;
	print '<?xml version="1.0" encoding="utf-8" ?>' . "\n" ;
	print '<Connector command="CreateFolder" resourceType="' . XMLEncode( $type ) . '">' . "\n" ;
	print '    <CurrentFolder path="' . XMLEncode( $cwd ) . '" url="' . XMLEncode( url( $actual_cwd ) ) . '" />' . "\n" ;
	print '    <Error number="' . $err_no . '" />' . "\n" ;
	print "</Connector>\n" ;
}


sub _run {
	my ( $actual_cwd ) = @_ ;
	
	
	my $newfolder = $_GET{ 'NewFolderName' } ;
	
	
	return 101 if ( ! defined( $newfolder ) ) ;
	return 101 if ( $newfolder eq '' ) ;
	
	my $pattern = $fckperl_config{ 'DisableName' } ;
	return 101 if ( $newfolder =~ /$pattern/ ) ;
	
	my $pattern = $fckperl_config{ 'DisableChars' } ;
	return 102 if ( $newfolder =~ /$pattern/ ) ;
	
	my $newdir = $actual_cwd . $newfolder . "/" ;
	
	#Check if it already exists
	return 104 if ( -f path( $newdir ) ) ;			#Folder or file already exists
	
	return 110 if ( mapFolder( $newdir ) == 0 ) ;	#Unknown error
	
	return 0;	#Success
}


1;
