sub run {
	my ( $type, $cwd ) = @_ ;
	
	
	my $actual_cwd = $fckperl_config{ 'UserFilesPath' } . "/" . $type . $cwd ;
	my $foldername = $_GET{ 'FolderName' } ;
	
	my $err_no = _run( $actual_cwd . $foldername . "/" ) ;
	
	print 'Content-Type: application/xml; charset=utf-8' . "\n" ;
	print "\n" ;
	print '<?xml version="1.0" encoding="utf-8" ?>' . "\n" ;
	print '<Connector command="DeleteFolder" resourceType="' . XMLEncode( $type ) . '">' . "\n" ;
	print '    <CurrentFolder path="' . XMLEncode( $cwd ) . '" url="' . XMLEncode( url( $actual_cwd ) ) . '" />' . "\n" ;
	print '    <Error number="' . $err_no . '" />' . "\n" ;
	print "</Connector>\n" ;
}


sub _run {
	my ( $dir ) = @_ ;
	
	
	opendir( my $dh, path( $dir ) ) ;
	
	my $err = 0 ;
	
	while ( defined( my $entry = readdir( $dh ) ) ) {
		next if ( $entry eq "." ) ;
		next if ( $entry eq ".." ) ;
		
		Jcode::convert( \$entry, 'utf8', $fckperl_config{ 'FileEncoding' } );
		
		if ( -d path( $dir . $entry . "/" ) ) {
			$err = _run( $dir . $entry . "/" ) ;
			last if ( $err != 0 ) ;
			
			next ;
		}
		
		if ( ! unlink( path( $dir . $entry ) ) ) {
			$err = 110 ;
			last ;
		}
	}
	
	closedir( $dh ) ;
	
	return $err if ( $err != 0 ) ;
	
	return ( rmdir( path( $dir ) ) ) ? 0 : 110;
}


1;
