use vars qw(%_POST %_GET) ;

sub _security {
	return 1 ;
}


sub run {
	my ( $type, $cwd ) = @_ ;
	
	
	my $actual_cwd = $fckperl_config{ 'UserFilesPath' } . "/" . $type . $cwd ;
	
	my $disp = _run( $type, $actual_cwd ) ;
	
	print 'Content-Type: text/html; charset=UTF-8' . "\n" ;
	print "\n" ;
	print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">' . "\n" ;
	print '<html>' . "\n" ;
	print '    <head>' . "\n" ;
	print '        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">' . "\n" ;
	print '        <title>Upload Complete</title>' . "\n" ;
	print '    </head>' . "\n" ;
	print '    <body>' . "\n" ;
	print '        <script type="text/javascript">' . "\n" ;
	print 'window.parent.frames[\'frmUpload\'].OnUploadCompleted(' . $disp . ') ;' . "\n" ;
	print '        </script>' . "\n" ;
	print '    </body>' . "\n" ;
	print '</html>' . "\n" ;
}


sub _run {
	my ( $type, $actual_cwd ) = @_ ;
	
	
	if ( _security() != 1 ) return "101" ;
	
	post_decode() ;
	
	return "203" if ( ! defined( $_FILES{ "NewFile" } ) ) ;
	
	my $newname = $_FILES{ 'NewFile' }{ 'name' } ;
	
	return "101" if ( $newname eq '' ) ;
	
	my $pattern = $fckperl_config{ 'DisableName' } ;
	return "101" if ( $newname =~ /$pattern/ ) ;
	
	my $pattern = $fckperl_config{ 'DisableChars' } ;
	return "102" if ( $newname =~ /$pattern/ ) ;
	
	my %typeconfig = %{ $fckperl_config{ 'ResourceAreas' }{ $type } } ;
	
	if ( $_FILES{ 'NewFile' }{ 'size' } > ( $typeconfig{ 'MaxSize' } * 1024 ) ) {
		return "204,'" . $typeconfig{ 'MaxSize' } . "'" ;
	}
	
	return "205" unless ( $newname =~ /^(.*)\.([^\.]+)$/ ) ;
	
	my $filename = $1 ;
	my $ext = $2 ;
	
	return "206,'{$ext}'" if ( ! in_array( lc( $ext ), \@{ $typeconfig{ 'AllowedExtensions' } } ) ) ;
	
	return "110" if ( ! mapFolder( $actual_cwd ) ) ;
	
	my $test = 0;
	my @dirSizes ;
	my $globalSize = 0;
	
	if ($fckperl_config{ 'DiskQuota' }{ 'Global' } != -1 ) {
		foreach $resType ( @{ $fckperl_config{ 'ResourceTypes' } } ) {
			my $path = $fckperl_config{ 'UserFilesPath'} . "/" . $resType ;
			
			if ( -d path($path) ) {
				$dirSizes{ $resType } = getDirSize( $path );
				
				if ( $dirSizes{ $resType } == -1 ) {
					return "207,'${ resType }'";
				}
			} else {
				$dirSizes{ $resType } = 0;
			}
			
			$globalSize += $dirSizes{ $resType } ;
		}
		
		$globalSize += $_FILES{ 'NewFile' }{ 'size' } ;
		
		if ( $globalSize > ( $fckperl_config{ 'DiskQuota' }{ 'Global' } * 1024 * 1024 ) ) {
			return "208,'" . $fckperl_config{ 'DiskQuota' }{ 'Global' } . "'";
		}
	}
	
	if ( $typeconfig{ 'DiskQuota' } != -1) {
		if ( $fckperl_config{ 'DiskQuota' }{ 'Global' } == -1 ) {
			my $path = $fckperl_config{ 'UserFilesPath'} . "/" . $type ;
			
			if ( -d path( $path ) ) {
				$dirSizes{ $type } = getDirSize( $path ) ;
				
				if ( $dirSizes{ $type } == -1 ) {
					return "207,'${ type }'";
				}
			} else {
				$dirSizes{ $type } = 0;
			}
		}
		
		if ( ( $dirSizes{ $type } + $_FILES{ 'NewFile' }{ 'size' } ) > ( $typeconfig{ 'DiskQuota' } * 1024 * 1024 ) ) {
			return "209,'" . $typeconfig{ 'DiskQuota' } . "'";
		}
	}
	
	my $unique = $filename ;
	my $done = 0 ;
	
	for ( my $i = 1; $i < $fckperl_config{ 'AvailableMax' }; $i++ ) {
		if ( ! -f path( "${ actual_cwd }${ unique }.${ ext }" ) ) {
			$done = 1 ;
			last ;
		}
		
		$unique = "${ filename }(${ i })" ;
	}
	
	return "210" if ( ! $done ) ;
	
	open( my $fh, ">" . path( "${ actual_cwd }${ unique }.${ ext }" ) ) ;
	binmode( $fh ) ;
	print $fh $_FILES{ 'NewFile' }{ 'data' } ;
	close( $fh ) ;
	
	return "212" if ( ! -f path("${ actual_cwd }${ unique }.${ ext }" ) ) ;
	
	return ( $unique eq $filename ) ? "0" : "1,'${ unique }.${ ext }'" ;
}


sub getDirSize {
	my ( $dir ) = @_ ;
	
	
	my $dirSize = 0 ;
	
	opendir( my $dh, path( $dir ) ) ;
	
	while ( defined( my $file = readdir( $dh ) ) ) {
		next if ( $file eq "." ) ;
		next if ( $file eq ".." ) ;
		
		Jcode::convert( \$file, 'utf8', $fckperl_config{ 'FileEncoding' } ) ;
		
		if ( -d path( $dir . "/" . $file ) ) {
			my $tmp_dirSize = getDirSize( $dir . "/" . $file ) ;
			
			if ( $tmp_dirSize == -1 ) {
				$dirSize = -1 ;
				last ;
			}
			
			$dirSize += $tmp_dirSize ;
			
			next ;
		}
		
		$dirSize += ( stat( path( $dir . "/" . $file ) ) )[ 7 ] ;
	}
	
	closedir( $dh ) ;
	
	return $dirSize ;
}

#------------------------------------------------------------------------------
# paese POST

sub post_decode {
	%_POST = () ;
	%_FILES = () ;
	
	# POST ̵
	
	return unless ( $ENV{ 'REQUEST_METHOD' } eq "POST" ) ;
	
	# ѥ᡼
	
	my $string ;
	
	binmode( STDIN ) ;
	read( STDIN, $string, $ENV{ 'CONTENT_LENGTH' } ) ;
	
	# multipart Ǥʤ
	
	if ( $ENV{ 'CONTENT_TYPE' } !~ /^multipart\/form-data; boundary=(.*)$/ ) {
		%_POST = query_decode( $string ) ;
		return ;
	}
	
	my $boundary = "--$1" ;
	
	# ѥ᡼̤ʬ
	
	return unless ( $string =~ /^$boundary(.?\n)/ ) ;
	my $separator = $1 ;
	
	my @lines = split( /$boundary/, $string, -1 ) ;
	shift( @lines ) ;
	pop( @lines ) ;
	
	# ѥ᡼
	
	foreach my $line ( @lines ) {
		$line =~ s/^$separator// ;
		$line =~ s/$separator$// ;
		
		my $pos = index( $line, "$separator$separator" ) ;
		my @header = split( /$separator/, substr( $line, 0, $pos ), -1 ) ;
		
		next unless ( $header[ 0 ] =~ /^Content-Disposition: form-data; name=\"([^\"]*)\"(; filename=\"([^\"]*)\")?$/ ) ;
		
		my ( $key, $file, $filename ) = ( $1, $2, $3 ) ;
		
		$pos += length( $separator ) * 2 ;
		
		if ( $file eq '' ) {
			$_POST{ $key } = substr( $line, $pos ) ;
			next ;
		}
		
		if ( $filename eq '' ) {
			$_FILES{ $key }{ 'name' } = '' ;
			$_FILES{ $key }{ 'data' } = '' ;
			$_FILES{ $key }{ 'size' } = 0 ;
			$_FILES{ $key }{ 'type' } = '' ;
			$_FILES{ $key }{ 'error' } = 4 ;
			
			next ;
		}
		
		my $filetype = '' ;
		
		if ( defined( $header[ 1 ] ) ) {
			if ( $header[ 1 ] =~ /^Content-Type: (.*)$/ ) {
				$filetype = $1 ;
			}
		}
		
		$_FILES{ $key }{ 'name' } = basename( $filename ) ;
		$_FILES{ $key }{ 'data' } = substr( $line, $pos ) ;
		$_FILES{ $key }{ 'size' } = length( $_FILES{ $key }{ 'data' } ) ;
		$_FILES{ $key }{ 'type' } = $filetype ;
		$_FILES{ $key }{ 'error' } = 0 ;
	}
}


1;