sub run {
	my ( $type, $cwd ) = @_ ;
	
	
	my $actual_cwd = $fckperl_config{ 'UserFilesPath' } . "/" . $type . $cwd ;
	
	my $filename = $_GET{ 'FileName' } ;
	my $newname = $_GET{ 'NewName' } ;
	
	my $err_no = _run( $actual_cwd, $filename, $newname ) ;
	
	print 'Content-Type: application/xml; charset=utf-8' . "\n" ;
	print "\n" ;
	print '<?xml version="1.0" encoding="utf-8" ?>' . "\n" ;
	print '<Connector command="RenameFolder" resourceType="' . XMLEncode( $type ) . '">' . "\n" ;
	print '    <CurrentFolder path="' . XMLEncode( $cwd ) . '" url="' . XMLEncode( url( $actual_cwd ) ) . '" />' . "\n" ;
	print '    <Error number="' . $err_no . '" />' . "\n" ;
	print "</Connector>\n" ;
}


sub _run {
	my ( $actual_cwd, $filename, $newname ) = @_ ;
	
	
	$filename =~ /^.+\.([^\.]*)$/ ;
	my $fileext = $1 ;
	
	return 101 if ( $newname eq '' ) ;
	
	$pattern = $fckperl_config{ 'DisableName' } ;
	return 101 if ( $newname =~ /$pattern/ ) ;
	
	return 101 if ( $newname !~ /^.+\.([^\.]*)$/ ) ;
	my $newext = $1 ;
	
	$pattern = $fckperl_config{ 'DisableChars' } ;
	return 102 if ( $newname =~ /$pattern/ ) ;
	
	return 105 if ( $newext ne $fileext ) ;
	
	return 103 if ( ! -f path( $actual_cwd . $filename ) ) ;
	return 104 if ( -e path( $actual_cwd . $newname ) ) ;
	
	my $thumb = $actual_cwd . ".thumb_" . $filename ;
	
	if ( -f path( $thumb ) ) {
		return 110 if ( ! unlink( path( $thumb ) ) ) ;
	}
	
	return ( rename( path( $actual_cwd . $filename ), path( $actual_cwd . $newname ) ) ) ? 0 : 110 ;
}


1;
