sub run {
	my ( $type, $cwd ) = @_ ;
	
	
	my $actual_cwd = $fckperl_config{ 'UserFilesPath' } . "/" . $type . $cwd ;
	
	my $foldername = $_GET{ 'FolderName' } ;
	my $newname = $_GET{ 'NewName' } ;
	
	my $err_no = _run( $actual_cwd, $foldername, $newname ) ;
	
	print 'Content-Type: application/xml; charset=utf-8' . "\n" ;
	print "\n" ;
	print '<?xml version="1.0" encoding="utf-8" ?>' . "\n" ;
	print '<Connector command="RenameFolder" resourceType="' . XMLEncode( $type ) . '">' . "\n" ;
	print '    <CurrentFolder path="' . XMLEncode( $cwd ) . '" url="' . XMLEncode( url( $actual_cwd ) ) . '" />' . "\n" ;
	print '    <Error number="' . $err_no . '" />' . "\n" ;
	print "</Connector>\n" ;
}


sub _run {
	my ( $actual_cwd, $foldername, $newname ) = @_ ;
	
	
	return 101 if ($newname eq '') ;
	
	$pattern = $fckperl_config{ 'DisableName' } ;
	return 101 if ( $newname =~ /$pattern/ ) ;
	
	$pattern = $fckperl_config{ 'DisableChars' } ;
	return 102 if ( $newname =~ /$pattern/ ) ;
	
	return 103 if ( ! -d path( $actual_cwd . $foldername ) ) ;
	return 104 if ( -e path( $actual_cwd . $newname ) ) ;
	
	return ( rename( path( $actual_cwd . $foldername ), path( $actual_cwd . $newname ) ) ) ? 0 : 110 ;
}


1;
