<?php
//### デザイン内各項目の記号にサンプルデータをハメ込む ###
if ($gyo>0) {
	$item = mb_substr(($item.'nnnnnnnnnnnnnnnnnnnnnnnnn'),0,25); // 25byte未満を補う
	for ($i = $gyo; $i >= 1; $i--) {
		$it_kind[$i] = mb_substr($item,$i-1,1);				// 種別（c=文字.i=イメージ）
		if ($it_kind[$i]=='c') {
			$stt=$db->prepare('SELECT item_name, item_type, item_unit, item_unit_pre FROM parts_item_c_m WHERE p_code = ? and p_seq = ?');
			$stt->bindParam(1, $p_code);
			$stt->bindParam(2, $i);
			try {
				$stt->execute();
				if ($cols = $stt->fetch(PDO::FETCH_ASSOC)) { 
					$it_name[$i] = mb_convert_encoding($cols['item_name'],"SJIS","UTF-8");
					$it_type[$i] = $cols['item_type'];
					$it_unit[$i] = mb_convert_encoding($cols['item_unit'],"SJIS","UTF-8");
					$it_unit_pre[$i] = $cols['item_unit_pre'];
					switch ($it_type[$i]) {
						case 'st':
							$ins_data = '「'.$it_name[$i].'」のデータ';
							break;
						case 'nc':	// breakせず下へ
						case 'nn':
							if ($it_type[$i]=='nc') {
								$ins_data = '12,345';
							} else {
								$ins_data = '12345';
							}
							if ($it_unit[$i]<>'') {
								if ($it_unit_pre[$i]=='1') {
									$ins_data = $it_unit[$i].$ins_data;
								} else {
									$ins_data = $ins_data.$it_unit[$i];
								}
							}
							break;
						case 'dy':
							$ins_data = date(Y).'/'.date(m).'/'.date(d);	// 今日の日付セット
							break;
					}
					$source = str_replace('[$$$'.$i.']',$ins_data,$source);
				}
			} catch (PDOException $e) {
				echo $e->getMessage();
				exit();
			}
		} else {
			$source = str_replace('[$$$'.$i.']',$images.'sample.gif',$source);
		}
	}
}
// ##### <hr />がある場合、最初と最後の<hr />を切れ目に（最大）三つに分割 #####
if ($source<>'') {
	$source = ' '.htmlspecialchars_decode($source);	// サーチ真偽判断し易くする為に、冒頭にスペース挿入（サーチ位置=0の場合考慮）
	$p01 = 0; $cnt = 0;
	while ($p01>=0) {
		$p02 = mb_strpos($source,'<hr',$p01);
		if ($p02>0) {
			$p03 = mb_strpos($source,'/>',$p02);
			if ($p03!==false) {
				++$cnt;
				$hr_st[$cnt] = $p02;
				$hr_en[$cnt] = $p03+2;
				if (($p03+2)<mb_strlen($source)) {
					$p01 = $p03+2;
				} else {
					$p01 = -999;
				}
			}
		} else {
			$p01 = -999;
		}
	}
}
if ($cnt>0) {
	$source1 = mb_substr($source,0,$hr_st[1]);
	if ($cnt>1) {
		$source2 = mb_substr($source,$hr_en[1],($hr_st[$cnt]-$hr_en[1]));
		$source3 = mb_substr($source,$hr_en[$cnt],(mb_strlen($source)-$hr_en[$cnt]));
	} else {
		$source2 = mb_substr($source,$hr_en[$cnt],(mb_strlen($source)-$hr_en[$cnt]));
		$source3 = '';
	}
} else {
	$source1 = '';
	$source2 = $source;
	$source3 = '';
}
//##### 表示 #####
echo '<div class="parts'.$p_code.'_'.$d_seq.'_'.$Cnt.'_1">';// 一番外側のdiv（marginのみ有効）
echo htmlspecialchars_decode($source1);						// 最初の<hr />より上のコンテンツ（あれば）
echo '<div class="parts'.$p_code.'_'.$d_seq.'_'.$Cnt.'_2">';// ２番目のdiv（margin以外有効）
echo htmlspecialchars_decode($source2);						// メインコンテンツ
echo '</div>';
echo htmlspecialchars_decode($source3);						// 最後の<hr />より下のコンテンツ（あれば）
echo '</div>';
?>